## chiaki 1.3.0+6e055d3

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 3.2)

project(chiaki)

# Like option(), but the value can also be AUTO
macro(tri_option name desc default)
    set("${name}" "${default}" CACHE STRING "${desc}")
    set_property(CACHE "${name}" PROPERTY STRINGS AUTO ON OFF)
endmacro()

option(CHIAKI_ENABLE_TESTS "Enable tests for Chiaki" ON)
option(CHIAKI_ENABLE_CLI "Enable CLI for Chiaki" OFF)
option(CHIAKI_ENABLE_GUI "Enable Qt GUI" ON)
option(CHIAKI_ENABLE_ANDROID "Enable Android (Use only as part of the Gradle Project)" OFF)
option(CHIAKI_ENABLE_SWITCH "Enable Nintendo Switch (Requires devKitPro libnx)" OFF)
tri_option(CHIAKI_ENABLE_SETSU "Enable libsetsu for touchpad input from controller" AUTO)
option(CHIAKI_LIB_ENABLE_OPUS "Use Opus as part of Chiaki Lib" ON)
option(CHIAKI_LIB_ENABLE_MBEDTLS "Use mbedtls instead of OpenSSL as part of Chiaki Lib" OFF)
option(CHIAKI_LIB_OPENSSL_EXTERNAL_PROJECT "Use OpenSSL as CMake external project" OFF)
option(CHIAKI_GUI_ENABLE_SDL_GAMECONTROLLER "Use SDL Gamecontroller for Input" ON)
option(CHIAKI_CLI_ARGP_STANDALONE "Search for standalone argp lib for CLI" OFF)
tri_option(CHIAKI_USE_SYSTEM_JERASURE "Use system-provided jerasure instead of submodule" AUTO)
tri_option(CHIAKI_USE_SYSTEM_NANOPB "Use system-provided nanopb instead of submodule" AUTO)

set(CHIAKI_VERSION_MAJOR 1)
set(CHIAKI_VERSION_MINOR 3)
set(CHIAKI_VERSION_PATCH 0)
set(CHIAKI_VERSION ${CHIAKI_VERSION_MAJOR}.${CHIAKI_VERSION_MINOR}.${CHIAKI_VERSION_PATCH})

set(CPACK_PACKAGE_NAME "chiaki")
set(CPACK_PACKAGE_DESCRIPTION "Open Source PS4 remote play client")
set(CPACK_PACKAGE_VERSION_MAJOR ${CHIAKI_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${CHIAKI_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${CHIAKI_VERSION_PATCH})
set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
set(CPACK_DEBIAN_PACKAGE_DESCRIPTION ${CPACK_PACKAGE_DESCRIPTION})
set(CPACK_DEBIAN_PACKAGE_SECTION "games")
include(CPack)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake;${CMAKE_CURRENT_SOURCE_DIR}/setsu/cmake")

# configure nintendo switch toolchain
if(CHIAKI_ENABLE_SWITCH)
	# load switch.cmake toolchain form ./cmake folder
	# include(switch)
	# to compile borealis third party
	set(CMAKE_CXX_STANDARD 17)
	# TODO check if android ... or other versions are enabled
	# force mbedtls as crypto lib
	set(CHIAKI_LIB_ENABLE_MBEDTLS ON)

    if(CHIAKI_SWITCH_ENABLE_LINUX)
        # CHIAKI_SWITCH_ENABLE_LINUX is a special testing version
        # the aim is to troubleshoot nitendo switch chiaki verison
        # from a x86 linux os
        add_definitions(-DCHIAKI_SWITCH_ENABLE_LINUX)
        add_definitions(-DBOREALIS_RESOURCES="./switch/res/")
        set(CMAKE_BUILD_TYPE Debug)
        add_definitions(-DDEBUG_OPENGL)
    else()
	    add_definitions(-D__SWITCH__)
	    # use symbolic links to load font ..
	    add_definitions(-DBOREALIS_RESOURCES="romfs:/")
    endif()
endif()

if(CHIAKI_USE_SYSTEM_JERASURE)
	if(CHIAKI_USE_SYSTEM_JERASURE STREQUAL AUTO)
		find_package(Jerasure QUIET)
		set(CHIAKI_USE_SYSTEM_JERASURE ${Jerasure_FOUND})
	else()
		find_package(Jerasure REQUIRED)
		set(CHIAKI_USE_SYSTEM_JERASURE ON)
	endif()
endif()

find_package(PythonInterp 3 REQUIRED) # Make sure nanopb doesn't find Python 2.7 because Python 2 should just die.

if(CHIAKI_USE_SYSTEM_NANOPB)
	if(CHIAKI_USE_SYSTEM_NANOPB STREQUAL AUTO)
		find_package(Nanopb QUIET)
		set(CHIAKI_USE_SYSTEM_NANOPB ${Nanopb_FOUND})
	else()
		find_package(Nanopb REQUIRED)
		set(CHIAKI_USE_SYSTEM_NANOPB ON)
	endif()
endif()

add_subdirectory(third-party)

add_definitions(-DCHIAKI_VERSION_MAJOR=${CHIAKI_VERSION_MAJOR} -DCHIAKI_VERSION_MINOR=${CHIAKI_VERSION_MINOR} -DCHIAKI_VERSION_PATCH=${CHIAKI_VERSION_PATCH} -DCHIAKI_VERSION=\"${CHIAKI_VERSION}\")

if(CHIAKI_LIB_OPENSSL_EXTERNAL_PROJECT)
	include(OpenSSLExternalProject)
endif()

if(CHIAKI_LIB_ENABLE_MBEDTLS)
	add_definitions(-DCHIAKI_LIB_ENABLE_MBEDTLS)
endif()

add_subdirectory(lib)

if(CHIAKI_ENABLE_CLI)
	add_subdirectory(cli)
endif()

if(CHIAKI_ENABLE_SETSU)
	find_package(Udev QUIET)
	find_package(Evdev QUIET)
	if(Udev_FOUND AND Evdev_FOUND)
		set(CHIAKI_ENABLE_SETSU ON)
	else()
		if(NOT CHIAKI_ENABLE_SETSU STREQUAL AUTO)
			message(FATAL_ERROR "
CHIAKI_ENABLE_SETSU is set to ON, but its dependencies (udev and evdev) could not be resolved.
Keep in mind that setsu is only supported on Linux!")
		endif()
		set(CHIAKI_ENABLE_SETSU OFF)
	endif()
	if(CHIAKI_ENABLE_SETSU)
		add_subdirectory(setsu)
	endif()
endif()

if(CHIAKI_ENABLE_SETSU)
	message(STATUS "Setsu enabled")
else()
	message(STATUS "Setsu disabled")
endif()

if(CHIAKI_ENABLE_GUI)
	#add_subdirectory(setsu)
	add_subdirectory(gui)
endif()

if(CHIAKI_ENABLE_TESTS)
	enable_testing()
	add_subdirectory(test)
endif()

if(CHIAKI_ENABLE_ANDROID)
	add_subdirectory(android/app)
endif()

if(CHIAKI_ENABLE_SWITCH)
	add_subdirectory(switch)
endif()

=== gui/CMakeLists.txt ===

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
find_package(Qt5 REQUIRED COMPONENTS Core Widgets Gui Multimedia OpenGL Svg)
if(APPLE)
	find_package(Qt5 REQUIRED COMPONENTS MacExtras)
endif()
if(CHIAKI_GUI_ENABLE_SDL_GAMECONTROLLER)
	find_package(SDL2 MODULE REQUIRED)
endif()

if(WIN32)
	add_definitions(-DWIN32_LEAN_AND_MEAN)
endif()

find_package(FFMPEG REQUIRED COMPONENTS avcodec avutil)

set(RESOURCE_FILES "")

if(APPLE)
	list(APPEND RESOURCE_FILES "chiaki.icns")
endif()

add_executable(chiaki WIN32
		${RESOURCE_FILES}
		include/exception.h
		src/main.cpp
		include/streamwindow.h
		src/streamwindow.cpp
		include/videodecoder.h
		src/videodecoder.cpp
		include/mainwindow.h
		src/mainwindow.cpp
		include/dynamicgridwidget.h
		src/dynamicgridwidget.cpp
		include/serveritemwidget.h
		src/serveritemwidget.cpp
		include/discoverymanager.h
		src/discoverymanager.cpp
		include/streamsession.h
		src/streamsession.cpp
		include/sessionlog.h
		src/sessionlog.cpp
		include/avopenglwidget.h
		src/avopenglwidget.cpp
		include/avopenglframeuploader.h
		src/avopenglframeuploader.cpp
		include/servericonwidget.h
		src/servericonwidget.cpp
		include/settings.h
		src/settings.cpp
		include/registdialog.h
		src/registdialog.cpp
		include/host.h
		src/host.cpp
		include/settingskeycapturedialog.h
		src/settingskeycapturedialog.cpp
		include/settingsdialog.h
		src/settingsdialog.cpp
		include/manualhostdialog.h
		src/manualhostdialog.cpp
		res/resources.qrc
		include/controllermanager.h
		src/controllermanager.cpp
		include/loginpindialog.h
		src/loginpindialog.cpp)
target_include_directories(chiaki PRIVATE include)

target_link_libraries(chiaki chiaki-lib)
if(CHIAKI_ENABLE_CLI)
	add_definitions(-DCHIAKI_ENABLE_CLI)
	target_link_libraries(chiaki chiaki-cli-lib)
endif()

target_link_libraries(chiaki FFMPEG::avcodec FFMPEG::avutil)
target_link_libraries(chiaki Qt5::Core Qt5::Widgets Qt5::Gui Qt5::Multimedia Qt5::OpenGL Qt5::Svg)
if(APPLE)
	target_link_libraries(chiaki Qt5::MacExtras)
	target_compile_definitions(chiaki PRIVATE CHIAKI_GUI_ENABLE_QT_MACEXTRAS)
endif()
if(CHIAKI_GUI_ENABLE_SDL_GAMECONTROLLER)
	target_link_libraries(chiaki SDL2::SDL2)
	target_compile_definitions(chiaki PRIVATE CHIAKI_GUI_ENABLE_SDL_GAMECONTROLLER)
endif()
if(CHIAKI_ENABLE_SETSU)
	target_link_libraries(chiaki setsu)
	target_compile_definitions(chiaki PRIVATE CHIAKI_GUI_ENABLE_SETSU)
endif()

set_target_properties(chiaki PROPERTIES
		MACOSX_BUNDLE TRUE
		MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/MacOSXBundleInfo.plist.in"
		MACOSX_BUNDLE_BUNDLE_NAME Chiaki
		MACOSX_BUNDLE_BUNDLE_VERSION ${CHIAKI_VERSION}
		MACOSX_BUNDLE_COPYRIGHT "thestr4ng3r (GPLv3)"
		MACOSX_BUNDLE_GUI_IDENTIFIER "org.chiaki.chiaki"
		MACOSX_BUNDLE_ICON_FILE chiaki.icns
		RESOURCE "${RESOURCE_FILES}")

install(TARGETS chiaki
		RUNTIME DESTINATION bin
		BUNDLE DESTINATION bin)
install(FILES chiaki.desktop DESTINATION share/applications)
install(FILES chiaki.png DESTINATION share/icons/hicolor/512x512/apps)
install(FILES re.chiaki.Chiaki.appdata.xml DESTINATION share/metainfo)

=== lib/CMakeLists.txt ===

set(HEADER_FILES
		include/chiaki/session.h
		include/chiaki/common.h
		include/chiaki/sock.h
		include/chiaki/thread.h
		include/chiaki/base64.h
		include/chiaki/http.h
		include/chiaki/log.h
		include/chiaki/ctrl.h
		include/chiaki/rpcrypt.h
		include/chiaki/takion.h
		include/chiaki/senkusha.h
		include/chiaki/streamconnection.h
		include/chiaki/ecdh.h
		include/chiaki/launchspec.h
		include/chiaki/random.h
		include/chiaki/gkcrypt.h
		include/chiaki/audio.h
		include/chiaki/audioreceiver.h
		include/chiaki/video.h
		include/chiaki/videoreceiver.h
		include/chiaki/frameprocessor.h
		include/chiaki/seqnum.h
		include/chiaki/discovery.h
		include/chiaki/congestioncontrol.h
		include/chiaki/stoppipe.h
		include/chiaki/reorderqueue.h
		include/chiaki/discoveryservice.h
		include/chiaki/feedback.h
		include/chiaki/feedbacksender.h
		include/chiaki/controller.h
		include/chiaki/takionsendbuffer.h
		include/chiaki/time.h
		include/chiaki/fec.h
		include/chiaki/regist.h
		include/chiaki/opusdecoder.h)

set(SOURCE_FILES
		src/common.c
		src/sock.c
		src/session.c
		src/thread.c
		src/base64.c
		src/http.c
		src/log.c
		src/ctrl.c
		src/rpcrypt.c
		src/takion.c
		src/senkusha.c
		src/utils.h
		src/pb_utils.h
		src/streamconnection.c
		src/ecdh.c
		src/launchspec.c
		src/random.c
		src/gkcrypt.c
		src/audio.c
		src/audioreceiver.c
		src/videoreceiver.c
		src/frameprocessor.c
		src/discovery.c
		src/congestioncontrol.c
		src/stoppipe.c
		src/reorderqueue.c
		src/discoveryservice.c
		src/feedback.c
		src/feedbacksender.c
		src/controller.c
		src/takionsendbuffer.c
		src/time.c
		src/fec
		src/regist.c
		src/opusdecoder.c)

add_subdirectory(protobuf)
set_source_files_properties(${CHIAKI_LIB_PROTO_SOURCE_FILES} ${CHIAKI_LIB_PROTO_HEADER_FILES} PROPERTIES GENERATED TRUE)
include_directories("${CHIAKI_LIB_PROTO_INCLUDE_DIR}")

if(CHIAKI_LIB_ENABLE_OPUS)
	find_package(Opus REQUIRED)
	include_directories(${Opus_INCLUDE_DIRS})
endif()

add_library(chiaki-lib ${HEADER_FILES} ${SOURCE_FILES} ${CHIAKI_LIB_PROTO_SOURCE_FILES} ${CHIAKI_LIB_PROTO_HEADER_FILES})
configure_file(config.h.in include/chiaki/config.h)
target_include_directories(chiaki-lib PUBLIC "${CMAKE_CURRENT_BINARY_DIR}/include")

add_dependencies(chiaki-lib chiaki-pb)
set_target_properties(chiaki-lib PROPERTIES OUTPUT_NAME chiaki)

if(WIN32)
	target_link_libraries(chiaki-lib wsock32 ws2_32 bcrypt)
endif()

target_include_directories(chiaki-lib PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/include")

find_package(Threads REQUIRED)
target_link_libraries(chiaki-lib Threads::Threads)

if(CHIAKI_LIB_ENABLE_MBEDTLS)
	# provided by mbedtls-static (mbedtls-devel)
	find_library(MBEDTLS mbedtls)
	find_library(MBEDX509 mbedx509)
	find_library(MBEDCRYPTO mbedcrypto)
	target_link_libraries(chiaki-lib ${MBEDTLS} ${MBEDX509} ${MBEDCRYPTO})
elseif(CHIAKI_LIB_OPENSSL_EXTERNAL_PROJECT)
	target_link_libraries(chiaki-lib OpenSSL_Crypto)
else()
	# default
	find_package(OpenSSL REQUIRED)
	target_link_libraries(chiaki-lib OpenSSL::Crypto)
endif()

target_link_libraries(chiaki-lib Nanopb::nanopb)
target_link_libraries(chiaki-lib Jerasure::Jerasure)

if(CHIAKI_LIB_ENABLE_OPUS)
	target_link_libraries(chiaki-lib ${Opus_LIBRARIES})
endif()

=== setsu/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.2)

project(libsetsu)

option(SETSU_BUILD_DEMO "Build testing executable for libsetsu" OFF)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

add_library(setsu
	include/setsu.h
	src/setsu.c)

target_include_directories(setsu PUBLIC include)

find_package(Udev REQUIRED)
find_package(Evdev REQUIRED)
target_link_libraries(setsu Udev::libudev Evdev::libevdev)

if(SETSU_BUILD_DEMO)
	add_executable(setsu-demo
		demo/main.c)
	target_link_libraries(setsu-demo setsu)
endif()

=== switch/CMakeLists.txt ===

set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(FFMPEG REQUIRED COMPONENTS avcodec avutil swscale)
find_library(SDL2 SDL2)
find_library(SWRESAMPLE swresample)

# find -type f | grep -P '\.(h|cpp)$' | sed 's#\./#\t\t#g'
add_executable(chiaki WIN32
	src/discoverymanager.cpp
	src/settings.cpp
	src/io.cpp
	src/host.cpp
	src/main.cpp
	src/gui.cpp)

target_include_directories(chiaki PRIVATE include)

target_link_libraries(chiaki
	chiaki-lib
	borealis
	${SDL2}
	FFMPEG::avcodec
	FFMPEG::avutil
	FFMPEG::swscale
	${SWRESAMPLE}
	${SWSCALE})

# OS links
if(CHIAKI_SWITCH_ENABLE_LINUX)
	target_link_libraries(chiaki dl)
else()
	# libnx is forced by the switch toolchain
	find_library(Z z)
	find_library(GLAPI glapi)
	find_library(DRM_NOUVEAU drm_nouveau)
	target_link_libraries(chiaki ${Z} ${GLAPI} ${DRM_NOUVEAU})
endif()

install(TARGETS chiaki
	RUNTIME DESTINATION bin
	BUNDLE DESTINATION bin)

if(CHIAKI_ENABLE_SWITCH AND NOT CHIAKI_SWITCH_ENABLE_LINUX)
	add_nro_target(chiaki "chiaki" "Chiaki team" "${CHIAKI_VERSION}" "${CMAKE_SOURCE_DIR}/switch/res/icon.jpg" "${CMAKE_SOURCE_DIR}/switch/res")
endif()

=== third-party/CMakeLists.txt ===

if(NOT CHIAKI_USE_SYSTEM_NANOPB)
	##################
	# nanopb
	##################

	add_subdirectory(nanopb EXCLUDE_FROM_ALL)
	set(NANOPB_GENERATOR_PY "${CMAKE_CURRENT_SOURCE_DIR}/nanopb/generator/nanopb_generator.py" PARENT_SCOPE)
	add_library(nanopb INTERFACE)
	target_link_libraries(nanopb INTERFACE protobuf-nanopb-static)
	target_include_directories(nanopb INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}/nanopb")
	add_library(Nanopb::nanopb ALIAS nanopb)
endif()

if(NOT CHIAKI_USE_SYSTEM_JERASURE)
	##################
	# gf-complete
	##################

	set(GF_COMPLETE_SOURCE
			gf-complete/src/gf.c
			gf-complete/src/gf_wgen.c
			gf-complete/src/gf_w4.c
			gf-complete/src/gf_w8.c
			gf-complete/src/gf_w16.c
			gf-complete/src/gf_w32.c
			gf-complete/src/gf_w64.c
			gf-complete/src/gf_w128.c
			gf-complete/src/gf_rand.c
			gf-complete/src/gf_general.c
			gf-complete/src/gf_cpu.c)

	# TODO: support NEON

	add_library(gf_complete STATIC ${GF_COMPLETE_SOURCE})
	target_include_directories(gf_complete PUBLIC gf-complete/include)

	##################
	# jerasure
	##################

	set(JERASURE_SOURCE
			jerasure/src/galois.c
			jerasure/src/jerasure.c
			jerasure/src/reed_sol.c
			jerasure/src/cauchy.c
			jerasure/src/liberation.c)

	add_library(jerasure STATIC ${JERASURE_SOURCE})
	target_include_directories(jerasure PUBLIC jerasure/include)
	target_link_libraries(jerasure gf_complete)

	add_library(Jerasure::Jerasure ALIAS jerasure)
endif()

##################
# borealis
##################

if(CHIAKI_ENABLE_SWITCH)
    # do not include
    # borealis/library/lib/switch_wrapper.c
    # switch functions are in switch/src/main.cpp
	set(BOREALIS_SOURCE
        borealis/library/lib/extern/libretro-common/features/features_cpu.c
        borealis/library/lib/extern/libretro-common/encodings/encoding_utf.c
        borealis/library/lib/extern/libretro-common/compat/compat_strl.c
        borealis/library/lib/extern/nxfmtwrapper/format.cpp
        borealis/library/lib/extern/nanovg/nanovg.c
        borealis/library/lib/extern/glad/glad.c
        borealis/library/lib/scroll_view.cpp
        borealis/library/lib/style.cpp
        borealis/library/lib/table.cpp
        borealis/library/lib/task_manager.cpp
        borealis/library/lib/progress_display.cpp
        borealis/library/lib/staged_applet_frame.cpp
        borealis/library/lib/applet_frame.cpp
        borealis/library/lib/hint.cpp
        borealis/library/lib/image.cpp
        borealis/library/lib/logger.cpp
        borealis/library/lib/swkbd.cpp
        borealis/library/lib/crash_frame.cpp
        borealis/library/lib/header.cpp
        borealis/library/lib/progress_spinner.cpp
        borealis/library/lib/layer_view.cpp
        borealis/library/lib/notification_manager.cpp
        borealis/library/lib/rectangle.cpp
        borealis/library/lib/application.cpp
        borealis/library/lib/box_layout.cpp
        borealis/library/lib/sidebar.cpp
        borealis/library/lib/dropdown.cpp
        borealis/library/lib/popup_frame.cpp
        borealis/library/lib/repeating_task.cpp
        borealis/library/lib/absolute_layout.cpp
        borealis/library/lib/i18n.cpp
        borealis/library/lib/tab_frame.cpp
        borealis/library/lib/thumbnail_frame.cpp
        borealis/library/lib/animations.cpp
        borealis/library/lib/dialog.cpp
        borealis/library/lib/view.cpp
        borealis/library/lib/list.cpp
        borealis/library/lib/button.cpp
        borealis/library/lib/label.cpp
        borealis/library/lib/theme.cpp
        borealis/library/lib/material_icon.cpp)

	add_library(borealis STATIC ${BOREALIS_SOURCE})
	target_include_directories(borealis PUBLIC
		borealis/library/include
        borealis/library/include/borealis/extern
		borealis/library/include/borealis/extern/glad
		borealis/library/include/borealis/extern/nanovg
		borealis/library/include/borealis/extern/libretro-common
		borealis/library/lib/extern/fmt/include)

    find_package(glfw3 REQUIRED)
	find_library(EGL EGL)
	find_library(GLAPI glapi)
	find_library(DRM_NOUVEAU drm_nouveau)
	target_link_libraries(borealis
		glfw
		${EGL}
		${GLAPI}
		${DRM_NOUVEAU})
endif()

=== debian/changelog ===
chiaki (1.3.0+6e055d3-1) unstable; urgency=medium

  * Initial release (Closes: #949550)

 -- Bartosz Fenski <fenio@debian.org>  Tue, 27 Oct 2020 18:31:34 +0100

=== debian/control ===
Source: chiaki
Section: utils
Priority: optional
Maintainer: Bartosz Fenski <fenio@debian.org>
Build-Depends: debhelper-compat (= 13), cmake, nanopb, libnanopb-dev, libopus-dev, libjerasure-dev, libssl-dev, qtmultimedia5-dev, libevdev-dev, libudev-dev, libqt5opengl5-dev, libqt5svg5-dev, libsdl2-dev, libswscale-dev, libavcodec-dev, python3-protobuf
Standards-Version: 4.5.0
Homepage: https://github.com/thestr4ng3r/chiaki/
Rules-Requires-Root: no

Package: chiaki
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: PlayStation 4 remote play client
 Chiaki is an unofficial, free and open source PlayStation 4 Remote Play Client.
 While not an official Sony software, Chiaki doesn't require a jailbroken PS4.
 .
 Everything necessary for a full streaming session, including the initial 
 registration and wakeup of the console, is supported.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

%:
	dh $@ 

override_dh_auto_configure:
	dh_auto_configure -- -DCHIAKI_ENABLE_TESTS=OFF

override_dh_installman:
	dh_installman --sourcedir debian

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
   https://github.com/thestr4ng3r/chiaki/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## chiaki 2.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,9 +13,16 @@
 option(CHIAKI_ENABLE_CLI "Enable CLI for Chiaki" OFF)
 option(CHIAKI_ENABLE_GUI "Enable Qt GUI" ON)
 option(CHIAKI_ENABLE_ANDROID "Enable Android (Use only as part of the Gradle Project)" OFF)
-option(CHIAKI_ENABLE_SWITCH "Enable Nintendo Switch (Requires devKitPro libnx)" OFF)
+option(CHIAKI_ENABLE_BOREALIS "Enable Borealis GUI (For Nintendo Switch or PC)" OFF)
 tri_option(CHIAKI_ENABLE_SETSU "Enable libsetsu for touchpad input from controller" AUTO)
 option(CHIAKI_LIB_ENABLE_OPUS "Use Opus as part of Chiaki Lib" ON)
+if(CHIAKI_ENABLE_GUI OR CHIAKI_ENABLE_BOREALIS)
+	set(CHIAKI_FFMPEG_DEFAULT ON)
+else()
+	set(CHIAKI_FFMPEG_DEFAULT AUTO)
+endif()
+tri_option(CHIAKI_ENABLE_FFMPEG_DECODER "Enable FFMPEG video decoder" ${CHIAKI_FFMPEG_DEFAULT})
+tri_option(CHIAKI_ENABLE_PI_DECODER "Enable Raspberry Pi-specific video decoder (requires libraspberrypi0 and libraspberrypi-doc)" AUTO)
 option(CHIAKI_LIB_ENABLE_MBEDTLS "Use mbedtls instead of OpenSSL as part of Chiaki Lib" OFF)
 option(CHIAKI_LIB_OPENSSL_EXTERNAL_PROJECT "Use OpenSSL as CMake external project" OFF)
 option(CHIAKI_GUI_ENABLE_SDL_GAMECONTROLLER "Use SDL Gamecontroller for Input" ON)
@@ -23,9 +30,9 @@
 tri_option(CHIAKI_USE_SYSTEM_JERASURE "Use system-provided jerasure instead of submodule" AUTO)
 tri_option(CHIAKI_USE_SYSTEM_NANOPB "Use system-provided nanopb instead of submodule" AUTO)
 
-set(CHIAKI_VERSION_MAJOR 1)
-set(CHIAKI_VERSION_MINOR 3)
-set(CHIAKI_VERSION_PATCH 0)
+set(CHIAKI_VERSION_MAJOR 2)
+set(CHIAKI_VERSION_MINOR 0)
+set(CHIAKI_VERSION_PATCH 1)
 set(CHIAKI_VERSION ${CHIAKI_VERSION_MAJOR}.${CHIAKI_VERSION_MINOR}.${CHIAKI_VERSION_PATCH})
 
 set(CPACK_PACKAGE_NAME "chiaki")
@@ -38,31 +45,16 @@
 set(CPACK_DEBIAN_PACKAGE_SECTION "games")
 include(CPack)
 
+set(CHIAKI_IS_SWITCH ${NSWITCH})
+
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake;${CMAKE_CURRENT_SOURCE_DIR}/setsu/cmake")
 
-# configure nintendo switch toolchain
-if(CHIAKI_ENABLE_SWITCH)
-	# load switch.cmake toolchain form ./cmake folder
-	# include(switch)
-	# to compile borealis third party
-	set(CMAKE_CXX_STANDARD 17)
-	# TODO check if android ... or other versions are enabled
+set(CMAKE_CXX_STANDARD 11)
+
+if(CHIAKI_IS_SWITCH)
 	# force mbedtls as crypto lib
 	set(CHIAKI_LIB_ENABLE_MBEDTLS ON)
-
-    if(CHIAKI_SWITCH_ENABLE_LINUX)
-        # CHIAKI_SWITCH_ENABLE_LINUX is a special testing version
-        # the aim is to troubleshoot nitendo switch chiaki verison
-        # from a x86 linux os
-        add_definitions(-DCHIAKI_SWITCH_ENABLE_LINUX)
-        add_definitions(-DBOREALIS_RESOURCES="./switch/res/")
-        set(CMAKE_BUILD_TYPE Debug)
-        add_definitions(-DDEBUG_OPENGL)
-    else()
-	    add_definitions(-D__SWITCH__)
-	    # use symbolic links to load font ..
-	    add_definitions(-DBOREALIS_RESOURCES="romfs:/")
-    endif()
+	add_definitions(-D__SWITCH__)
 endif()
 
 if(CHIAKI_USE_SYSTEM_JERASURE)
@@ -97,6 +89,44 @@
 
 if(CHIAKI_LIB_ENABLE_MBEDTLS)
 	add_definitions(-DCHIAKI_LIB_ENABLE_MBEDTLS)
+endif()
+
+if(CHIAKI_ENABLE_FFMPEG_DECODER)
+	find_package(FFMPEG COMPONENTS avcodec avutil)
+	if(FFMPEG_FOUND)
+		set(CHIAKI_ENABLE_FFMPEG_DECODER ON)
+	else()
+		if(NOT CHIAKI_ENABLE_FFMPEG_DECODER STREQUAL AUTO)
+			message(FATAL_ERROR "CHIAKI_ENABLE_FFMPEG_DECODER is set to ON, but ffmpeg could not be found.")
+		endif()
+		set(CHIAKI_ENABLE_FFMPEG_DECODER OFF)
+	endif()
+endif()
+
+if(CHIAKI_ENABLE_FFMPEG_DECODER)
+	message(STATUS "FFMPEG Decoder enabled")
+else()
+	message(STATUS "FFMPEG Decoder disabled")
+endif()
+
+if(CHIAKI_ENABLE_PI_DECODER)
+	find_package(ILClient)
+	if(ILClient_FOUND)
+		set(CHIAKI_ENABLE_PI_DECODER ON)
+	else()
+		if(NOT CHIAKI_ENABLE_PI_DECODER STREQUAL AUTO)
+			message(FATAL_ERROR "
+CHIAKI_ENABLE_PI_DECODER is set to ON, but its dependencies (ilclient source and libs) could not be resolved.
+The Raspberry Pi Decoder is only supported on Raspberry Pi OS and requires libraspberrypi0 and libraspberrypi-doc.")
+		endif()
+		set(CHIAKI_ENABLE_PI_DECODER OFF)
+	endif()
+endif()
+
+if(CHIAKI_ENABLE_PI_DECODER)
+	message(STATUS "Pi Decoder enabled")
+else()
+	message(STATUS "Pi Decoder disabled")
 endif()
 
 add_subdirectory(lib)
@@ -143,6 +173,6 @@
 	add_subdirectory(android/app)
 endif()
 
-if(CHIAKI_ENABLE_SWITCH)
+if(CHIAKI_ENABLE_BOREALIS)
 	add_subdirectory(switch)
 endif()

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -21,6 +21,7 @@
 		include/chiaki/video.h
 		include/chiaki/videoreceiver.h
 		include/chiaki/frameprocessor.h
+		include/chiaki/packetstats.h
 		include/chiaki/seqnum.h
 		include/chiaki/discovery.h
 		include/chiaki/congestioncontrol.h
@@ -59,6 +60,7 @@
 		src/audioreceiver.c
 		src/videoreceiver.c
 		src/frameprocessor.c
+		src/packetstats.c
 		src/discovery.c
 		src/congestioncontrol.c
 		src/stoppipe.c
@@ -73,6 +75,18 @@
 		src/regist.c
 		src/opusdecoder.c)
 
+if(CHIAKI_ENABLE_FFMPEG_DECODER)
+	list(APPEND HEADER_FILES include/chiaki/ffmpegdecoder.h)
+	list(APPEND SOURCE_FILES src/ffmpegdecoder.c)
+endif()
+set(CHIAKI_LIB_ENABLE_PI_DECODER "${CHIAKI_ENABLE_FFMPEG_DECODER}")
+
+if(CHIAKI_ENABLE_PI_DECODER)
+	list(APPEND HEADER_FILES include/chiaki/pidecoder.h)
+	list(APPEND SOURCE_FILES src/pidecoder.c)
+endif()
+set(CHIAKI_LIB_ENABLE_PI_DECODER "${CHIAKI_ENABLE_PI_DECODER}")
+
 add_subdirectory(protobuf)
 set_source_files_properties(${CHIAKI_LIB_PROTO_SOURCE_FILES} ${CHIAKI_LIB_PROTO_HEADER_FILES} PROPERTIES GENERATED TRUE)
 include_directories("${CHIAKI_LIB_PROTO_INCLUDE_DIR}")
@@ -85,6 +99,10 @@
 add_library(chiaki-lib ${HEADER_FILES} ${SOURCE_FILES} ${CHIAKI_LIB_PROTO_SOURCE_FILES} ${CHIAKI_LIB_PROTO_HEADER_FILES})
 configure_file(config.h.in include/chiaki/config.h)
 target_include_directories(chiaki-lib PUBLIC "${CMAKE_CURRENT_BINARY_DIR}/include")
+
+if(CMAKE_C_COMPILER_ID STREQUAL GNU OR CMAKE_C_COMPILER_ID STREQUAL Clang)
+	target_compile_options(chiaki-lib PRIVATE -Wall)
+endif()
 
 add_dependencies(chiaki-lib chiaki-pb)
 set_target_properties(chiaki-lib PROPERTIES OUTPUT_NAME chiaki)
@@ -115,6 +133,14 @@
 target_link_libraries(chiaki-lib Nanopb::nanopb)
 target_link_libraries(chiaki-lib Jerasure::Jerasure)
 
+if(CHIAKI_ENABLE_FFMPEG_DECODER)
+	target_link_libraries(chiaki-lib FFMPEG::avcodec FFMPEG::avutil)
+endif()
+
+if(CHIAKI_ENABLE_PI_DECODER)
+	target_link_libraries(chiaki-lib ILClient::ILClient)
+endif()
+
 if(CHIAKI_LIB_ENABLE_OPUS)
 	target_link_libraries(chiaki-lib ${Opus_LIBRARIES})
 endif()

=== switch/CMakeLists.txt ===

##################
# borealis dependency
##################

# do not include
# borealis/library/lib/switch_wrapper.c
# switch functions are in switch/src/main.cpp
set(BOREALIS_SOURCE
    borealis/library/lib/extern/libretro-common/features/features_cpu.c
    borealis/library/lib/extern/libretro-common/encodings/encoding_utf.c
    borealis/library/lib/extern/libretro-common/compat/compat_strl.c
    borealis/library/lib/extern/nxfmtwrapper/format.cpp
    borealis/library/lib/extern/nanovg/nanovg.c
    borealis/library/lib/extern/glad/glad.c
    borealis/library/lib/scroll_view.cpp
    borealis/library/lib/style.cpp
    borealis/library/lib/table.cpp
    borealis/library/lib/task_manager.cpp
    borealis/library/lib/progress_display.cpp
    borealis/library/lib/staged_applet_frame.cpp
    borealis/library/lib/applet_frame.cpp
    borealis/library/lib/hint.cpp
    borealis/library/lib/image.cpp
    borealis/library/lib/logger.cpp
    borealis/library/lib/swkbd.cpp
    borealis/library/lib/crash_frame.cpp
    borealis/library/lib/header.cpp
    borealis/library/lib/progress_spinner.cpp
    borealis/library/lib/layer_view.cpp
    borealis/library/lib/notification_manager.cpp
    borealis/library/lib/rectangle.cpp
    borealis/library/lib/application.cpp
    borealis/library/lib/box_layout.cpp
    borealis/library/lib/sidebar.cpp
    borealis/library/lib/dropdown.cpp
    borealis/library/lib/popup_frame.cpp
    borealis/library/lib/repeating_task.cpp
    borealis/library/lib/absolute_layout.cpp
    borealis/library/lib/i18n.cpp
    borealis/library/lib/tab_frame.cpp
    borealis/library/lib/thumbnail_frame.cpp
    borealis/library/lib/animations.cpp
    borealis/library/lib/dialog.cpp
    borealis/library/lib/view.cpp
    borealis/library/lib/list.cpp
    borealis/library/lib/button.cpp
    borealis/library/lib/label.cpp
    borealis/library/lib/theme.cpp
    borealis/library/lib/material_icon.cpp)

add_library(borealis STATIC ${BOREALIS_SOURCE})
set_property(TARGET borealis PROPERTY CXX_STANDARD 17)
target_include_directories(borealis PUBLIC
	borealis/library/include
    borealis/library/include/borealis/extern
	borealis/library/include/borealis/extern/glad
	borealis/library/include/borealis/extern/nanovg
	borealis/library/include/borealis/extern/libretro-common
	borealis/library/lib/extern/fmt/include)

find_package(glfw3 REQUIRED)
find_library(EGL EGL)
find_library(GLAPI glapi)
find_library(DRM_NOUVEAU drm_nouveau)
target_link_libraries(borealis
	glfw
	${EGL}
	${GLAPI}
	${DRM_NOUVEAU})

if(CHIAKI_IS_SWITCH)
	target_compile_definitions(borealis PUBLIC
		BOREALIS_RESOURCES="romfs:/")
else()
	target_compile_definitions(borealis PUBLIC
		BOREALIS_RESOURCES="./switch/res/")
endif()


##################
# chiaki with borealis
##################

find_package(FFMPEG REQUIRED COMPONENTS avcodec avutil swscale)
find_library(SDL2 SDL2)
find_library(SWRESAMPLE swresample)

# find -type f | grep -P '\.(h|cpp)$' | sed 's#\./#\t\t#g'
add_executable(chiaki-borealis WIN32
	src/discoverymanager.cpp
	src/settings.cpp
	src/io.cpp
	src/host.cpp
	src/main.cpp
	src/gui.cpp)

set_target_properties(chiaki-borealis PROPERTIES
	CXX_STANDARD 17
	OUTPUT_NAME chiaki)

target_include_directories(chiaki-borealis PRIVATE include)

target_link_libraries(chiaki-borealis
	chiaki-lib
	borealis
	${SDL2}
	FFMPEG::avcodec
	FFMPEG::avutil
	FFMPEG::swscale
	${SWRESAMPLE}
	${SWSCALE})

if(CHIAKI_IS_SWITCH)
	# libnx is forced by the switch toolchain
	find_library(Z z)
	find_library(GLAPI glapi) # TODO: make it transitive from borealis
	find_library(DRM_NOUVEAU drm_nouveau) # TODO: make it transitive from borealis
	target_link_libraries(chiaki-borealis ${Z} ${GLAPI} ${DRM_NOUVEAU})
endif()

install(TARGETS chiaki-borealis
	RUNTIME DESTINATION bin
	BUNDLE DESTINATION bin)

if(CHIAKI_IS_SWITCH)
	add_nro_target(chiaki
		chiaki-borealis
		"chiaki"
		"Chiaki team"
		"${CHIAKI_VERSION}"
		"${CMAKE_SOURCE_DIR}/switch/res/icon.jpg"
		"${CMAKE_SOURCE_DIR}/switch/res")
endif()

=== debian/changelog ===
chiaki (2.0.1-1) unstable; urgency=medium

  * New upstream version. 
    -relicensed on AGPL-3.0 with OpenSSL exception.

 -- Bartosz Fenski <fenio@debian.org>  Fri, 15 Jan 2021 17:16:30 +0100

chiaki (1.3.0+b70455d-1) unstable; urgency=medium

  * Initial release (Closes: #949550)

 -- Bartosz Fenski <fenio@debian.org>  Wed, 21 Oct 2020 18:31:34 +0200

=== debian/control ===
Source: chiaki
Section: utils
Priority: optional
Maintainer: Bartosz Fenski <fenio@debian.org>
Build-Depends: debhelper-compat (= 13), cmake, pkg-config, libopus-dev, qtmultimedia5-dev, libqt5svg5-dev, libsdl2-dev, libavcodec-dev, libswscale-dev, libjerasure-dev, libnanopb-dev, libssl-dev, protobuf-compiler, python3-protobuf, libevdev-dev, libudev-dev, libqt5opengl5-dev, python3-dev, libgl1-mesa-dev, imagemagick, librsvg2-bin, libpthread-stubs0-dev, libpthreadpool-dev, nanopb
Standards-Version: 4.5.0
Homepage: https://git.sr.ht/~thestr4ng3r/chiaki
Rules-Requires-Root: no

Package: chiaki
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: PlayStation remote play client
 Chiaki is an unofficial, free and open source PlayStation Remote Play Client.
 While not an official Sony software, Chiaki doesn't require having a jailbroken 
 console.
 .
 Everything necessary for a full streaming session, including the initial 
 registration and wakeup of the console, is supported.

## chiaki 2.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -31,8 +31,8 @@
 tri_option(CHIAKI_USE_SYSTEM_NANOPB "Use system-provided nanopb instead of submodule" AUTO)
 
 set(CHIAKI_VERSION_MAJOR 2)
-set(CHIAKI_VERSION_MINOR 0)
-set(CHIAKI_VERSION_PATCH 1)
+set(CHIAKI_VERSION_MINOR 1)
+set(CHIAKI_VERSION_PATCH 0)
 set(CHIAKI_VERSION ${CHIAKI_VERSION_MAJOR}.${CHIAKI_VERSION_MINOR}.${CHIAKI_VERSION_PATCH})
 
 set(CPACK_PACKAGE_NAME "chiaki")

=== cli/CMakeLists.txt ===

set(SOURCE
		include/chiaki-cli.h
		src/discover.c
		src/wakeup.c)

add_library(chiaki-cli-lib STATIC ${SOURCE})
target_include_directories(chiaki-cli-lib PUBLIC "include")
target_link_libraries(chiaki-cli-lib chiaki-lib)

if(CHIAKI_CLI_ARGP_STANDALONE)
	find_package(Argp REQUIRED)
	target_link_libraries(chiaki-cli-lib Argp::Argp)
endif()

add_executable(chiaki-cli src/main.c)
target_link_libraries(chiaki-cli chiaki-cli-lib)

=== gui/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
-find_package(Qt5 REQUIRED COMPONENTS Core Widgets Gui Multimedia OpenGL Svg)
+find_package(Qt5 REQUIRED COMPONENTS Core Widgets Gui Concurrent Multimedia OpenGL Svg)
 if(APPLE)
 	find_package(Qt5 REQUIRED COMPONENTS MacExtras)
 endif()
@@ -13,8 +13,6 @@
 if(WIN32)
 	add_definitions(-DWIN32_LEAN_AND_MEAN)
 endif()
-
-find_package(FFMPEG REQUIRED COMPONENTS avcodec avutil)
 
 set(RESOURCE_FILES "")
 
@@ -28,8 +26,6 @@
 		src/main.cpp
 		include/streamwindow.h
 		src/streamwindow.cpp
-		include/videodecoder.h
-		src/videodecoder.cpp
 		include/mainwindow.h
 		src/mainwindow.cpp
 		include/dynamicgridwidget.h
@@ -73,8 +69,7 @@
 	target_link_libraries(chiaki chiaki-cli-lib)
 endif()
 
-target_link_libraries(chiaki FFMPEG::avcodec FFMPEG::avutil)
-target_link_libraries(chiaki Qt5::Core Qt5::Widgets Qt5::Gui Qt5::Multimedia Qt5::OpenGL Qt5::Svg)
+target_link_libraries(chiaki Qt5::Core Qt5::Widgets Qt5::Gui Qt5::Concurrent Qt5::Multimedia Qt5::OpenGL Qt5::Svg)
 if(APPLE)
 	target_link_libraries(chiaki Qt5::MacExtras)
 	target_compile_definitions(chiaki PRIVATE CHIAKI_GUI_ENABLE_QT_MACEXTRAS)
@@ -87,13 +82,16 @@
 	target_link_libraries(chiaki setsu)
 	target_compile_definitions(chiaki PRIVATE CHIAKI_GUI_ENABLE_SETSU)
 endif()
+if(NOT CHIAKI_ENABLE_FFMPEG_DECODER)
+	message(FATAL_ERROR "Chiaki GUI requires CHIAKI_ENABLE_FFMPEG_DECODER=ON")
+endif()
 
 set_target_properties(chiaki PROPERTIES
 		MACOSX_BUNDLE TRUE
 		MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/MacOSXBundleInfo.plist.in"
 		MACOSX_BUNDLE_BUNDLE_NAME Chiaki
 		MACOSX_BUNDLE_BUNDLE_VERSION ${CHIAKI_VERSION}
-		MACOSX_BUNDLE_COPYRIGHT "thestr4ng3r (GPLv3)"
+		MACOSX_BUNDLE_COPYRIGHT "thestr4ng3r (AGPLv3)"
 		MACOSX_BUNDLE_GUI_IDENTIFIER "org.chiaki.chiaki"
 		MACOSX_BUNDLE_ICON_FILE chiaki.icns
 		RESOURCE "${RESOURCE_FILES}")

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -35,7 +35,8 @@
 		include/chiaki/time.h
 		include/chiaki/fec.h
 		include/chiaki/regist.h
-		include/chiaki/opusdecoder.h)
+		include/chiaki/opusdecoder.h
+		include/chiaki/orientation.h)
 
 set(SOURCE_FILES
 		src/common.c
@@ -73,7 +74,8 @@
 		src/time.c
 		src/fec
 		src/regist.c
-		src/opusdecoder.c)
+		src/opusdecoder.c
+		src/orientation.c)
 
 if(CHIAKI_ENABLE_FFMPEG_DECODER)
 	list(APPEND HEADER_FILES include/chiaki/ffmpegdecoder.h)

=== setsu/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.2)

project(libsetsu)

option(SETSU_BUILD_DEMOS "Build testing executables for libsetsu" OFF)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

add_library(setsu
	include/setsu.h
	src/setsu.c)

target_include_directories(setsu PUBLIC include)

find_package(Udev REQUIRED)
find_package(Evdev REQUIRED)
target_link_libraries(setsu Udev::libudev Evdev::libevdev)

if(SETSU_BUILD_DEMOS)
	add_executable(setsu-demo-touchpad demo/touchpad.c)
	target_link_libraries(setsu-demo-touchpad setsu)
	add_executable(setsu-demo-motion demo/motion.c)
	target_link_libraries(setsu-demo-motion setsu)
endif()

=== third-party/CMakeLists.txt ===

if(NOT CHIAKI_USE_SYSTEM_NANOPB)
	##################
	# nanopb
	##################

	add_subdirectory(nanopb EXCLUDE_FROM_ALL)
	set(NANOPB_GENERATOR_PY "${CMAKE_CURRENT_SOURCE_DIR}/nanopb/generator/nanopb_generator.py" PARENT_SCOPE)
	add_library(nanopb INTERFACE)
	target_link_libraries(nanopb INTERFACE protobuf-nanopb-static)
	target_include_directories(nanopb INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}/nanopb")
	add_library(Nanopb::nanopb ALIAS nanopb)
endif()

if(NOT CHIAKI_USE_SYSTEM_JERASURE)
	##################
	# gf-complete
	##################

	set(GF_COMPLETE_SOURCE
			gf-complete/src/gf.c
			gf-complete/src/gf_wgen.c
			gf-complete/src/gf_w4.c
			gf-complete/src/gf_w8.c
			gf-complete/src/gf_w16.c
			gf-complete/src/gf_w32.c
			gf-complete/src/gf_w64.c
			gf-complete/src/gf_w128.c
			gf-complete/src/gf_rand.c
			gf-complete/src/gf_general.c
			gf-complete/src/gf_cpu.c)

	# TODO: support NEON

	add_library(gf_complete STATIC ${GF_COMPLETE_SOURCE})
	target_include_directories(gf_complete PUBLIC gf-complete/include)

	##################
	# jerasure
	##################

	set(JERASURE_SOURCE
			jerasure/src/galois.c
			jerasure/src/jerasure.c
			jerasure/src/reed_sol.c
			jerasure/src/cauchy.c
			jerasure/src/liberation.c)

	add_library(jerasure STATIC ${JERASURE_SOURCE})
	target_include_directories(jerasure PUBLIC jerasure/include)
	target_link_libraries(jerasure gf_complete)

	add_library(Jerasure::Jerasure ALIAS jerasure)
endif()

=== lib/protobuf/CMakeLists.txt ===

find_program(PROTOC protoc)
if(NOT PROTOC)
	message(FATAL_ERROR "Could not find protoc")
endif()

add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/takion.pb"
		COMMAND "${PROTOC}" "-o${CMAKE_CURRENT_BINARY_DIR}/takion.pb" "${CMAKE_CURRENT_SOURCE_DIR}/takion.proto" "-I${CMAKE_CURRENT_SOURCE_DIR}"
		MAIN_DEPENDENCY "${CMAKE_CURRENT_SOURCE_DIR}/takion.proto")

set(SOURCE_FILES "${CMAKE_CURRENT_BINARY_DIR}/takion.pb.c")
set(HEADER_FILES "${CMAKE_CURRENT_BINARY_DIR}/takion.pb.h")

add_custom_command(OUTPUT ${SOURCE_FILES} ${HEADER_FILES}
		COMMAND "${PYTHON_EXECUTABLE}" "${NANOPB_GENERATOR_PY}" "${CMAKE_CURRENT_BINARY_DIR}/takion.pb"
		MAIN_DEPENDENCY "${CMAKE_CURRENT_BINARY_DIR}/takion.pb")

set(CHIAKI_LIB_PROTO_SOURCE_FILES "${SOURCE_FILES}" PARENT_SCOPE)
set(CHIAKI_LIB_PROTO_HEADER_FILES "${HEADER_FILES}" PARENT_SCOPE)
set(CHIAKI_LIB_PROTO_INCLUDE_DIR "${CMAKE_CURRENT_BINARY_DIR}" PARENT_SCOPE)

add_custom_target(chiaki-pb DEPENDS ${SOURCE_FILES} ${HEADER_FILES})

=== debian/changelog ===
chiaki (2.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Bumped Standards-Version (no changes needed) 

 -- Bartosz Fenski <fenio@debian.org>  Fri, 22 Jan 2021 17:41:51 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Bartosz Fenski <fenio@debian.org>
 Build-Depends: debhelper-compat (= 13), cmake, pkg-config, libopus-dev, qtmultimedia5-dev, libqt5svg5-dev, libsdl2-dev, libavcodec-dev, libswscale-dev, libjerasure-dev, libnanopb-dev, libssl-dev, protobuf-compiler, python3-protobuf, libevdev-dev, libudev-dev, libqt5opengl5-dev, python3-dev, libgl1-mesa-dev, imagemagick, librsvg2-bin, libpthread-stubs0-dev, libpthreadpool-dev, nanopb
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://git.sr.ht/~thestr4ng3r/chiaki
 Rules-Requires-Root: no
